diff --git a/platform/j784s4/rtos/gen_linker_mem_map.py b/platform/j784s4/rtos/gen_linker_mem_map.py
index 41ae483..f58884f 100755
--- a/platform/j784s4/rtos/gen_linker_mem_map.py
+++ b/platform/j784s4/rtos/gen_linker_mem_map.py
@@ -88,7 +88,7 @@ KB = 1024;
 MB = KB*KB;
 GB = KB*MB;
 
-SHARED_MEM_SIZE = 1024*MB;
+SHARED_MEM_SIZE = 512*MB;
 
 #
 # Notes,
@@ -115,7 +115,7 @@ SHARED_MEM_SIZE = 1024*MB;
 # virtual lower DDR address range 0x0001_0000_0000
 #
 
-ddr_mem_addr  = 0xa0000000;
+ddr_mem_addr  = 0x90000000;
 ddr_mem_size  = 1*GB + 448*MB; # Last 64MB is used by Linux
 
 ddr_mem_addr_hi_phys = 0x880000000;
@@ -309,11 +309,17 @@ c7x_4_ddr_secure_vecs_size = 16*KB;
 c7x_4_ddr_addr = c7x_4_ddr_resource_table_addr + 7*MB;
 c7x_4_ddr_size = 24*MB;
 
+ddr_intercore_eth_desc_addr = c7x_4_ddr_addr + c7x_4_ddr_size;
+ddr_intercore_eth_desc_size = 8*MB;
+
+ddr_intercore_eth_data_addr = ddr_intercore_eth_desc_addr + ddr_intercore_eth_desc_size;
+ddr_intercore_eth_data_size = 24*MB;
+
 #
 # DDR memory allocation for various shared memories
 #
 
-mcu1_0_ddr_local_heap_addr  = c7x_4_ddr_addr + c7x_4_ddr_size;
+mcu1_0_ddr_local_heap_addr  = ddr_intercore_eth_data_addr + ddr_intercore_eth_data_size;
 mcu1_0_ddr_local_heap_size  = 8*MB;
 mcu1_1_ddr_local_heap_addr  = mcu1_0_ddr_local_heap_addr + mcu1_0_ddr_local_heap_size;
 mcu1_1_ddr_local_heap_size  = 8*MB;
@@ -334,167 +340,90 @@ mcu4_0_ddr_viss_heap_size   = 2*MB;
 mcu4_1_ddr_local_heap_addr  = mcu4_0_ddr_viss_heap_addr + mcu4_0_ddr_viss_heap_size;
 mcu4_1_ddr_local_heap_size  = 8*MB;
 
-ddr_intercore_eth_desc_addr = mcu4_1_ddr_local_heap_addr + mcu4_1_ddr_local_heap_size;
-ddr_intercore_eth_desc_size = 8*MB;
-
-ddr_intercore_eth_data_addr = ddr_intercore_eth_desc_addr + ddr_intercore_eth_desc_size;
-ddr_intercore_eth_data_size = 24*MB;
-
-# Shared memory for DMA Buf FD carveout
-ddr_shared_mem_addr     = ddr_intercore_eth_data_addr + ddr_intercore_eth_data_size;
-ddr_shared_mem_size     = SHARED_MEM_SIZE - uboot_reloc_mem_size;
-
 # C7x 1 Persistent DDR
-c7x_1_ddr_local_heap_non_cacheable_addr  = ddr_mem_addr_hi;
-c7x_1_ddr_local_heap_non_cacheable_addr_phys  = ddr_mem_addr_hi_phys;
-c7x_1_ddr_local_heap_non_cacheable_size  = 128*MB;
+c7x_1_ddr_local_heap_non_cacheable_addr  = mcu4_1_ddr_local_heap_addr + mcu4_1_ddr_local_heap_size;
+c7x_1_ddr_local_heap_non_cacheable_addr_phys  = mcu4_1_ddr_local_heap_addr + mcu4_1_ddr_local_heap_size;
+c7x_1_ddr_local_heap_non_cacheable_size  = 32*MB;
 c7x_1_ddr_local_heap_addr = c7x_1_ddr_local_heap_non_cacheable_addr + c7x_1_ddr_local_heap_non_cacheable_size;
 c7x_1_ddr_local_heap_addr_phys = c7x_1_ddr_local_heap_non_cacheable_addr_phys + c7x_1_ddr_local_heap_non_cacheable_size;
-c7x_1_ddr_local_heap_size = 128*MB;
+c7x_1_ddr_local_heap_size = 32*MB;
 total_c7x_1_local_ddr = c7x_1_ddr_local_heap_non_cacheable_size + c7x_1_ddr_local_heap_size;
 
 # C7x 1 Scratch DDR
 c7x_1_ddr_scratch_non_cacheable_addr      = c7x_1_ddr_local_heap_addr + c7x_1_ddr_local_heap_size;
 c7x_1_ddr_scratch_non_cacheable_addr_phys = c7x_1_ddr_local_heap_addr_phys + c7x_1_ddr_local_heap_size;
-c7x_1_ddr_scratch_non_cacheable_size      = 128*MB;
+c7x_1_ddr_scratch_non_cacheable_size      = 32*MB;
 c7x_1_ddr_scratch_addr = c7x_1_ddr_scratch_non_cacheable_addr + c7x_1_ddr_scratch_non_cacheable_size;
 c7x_1_ddr_scratch_addr_phys = c7x_1_ddr_scratch_non_cacheable_addr_phys + c7x_1_ddr_scratch_non_cacheable_size;
-c7x_1_ddr_scratch_size = 128*MB;
+c7x_1_ddr_scratch_size = 32*MB;
 total_c7x_1_scratch_ddr = c7x_1_ddr_scratch_non_cacheable_size + c7x_1_ddr_scratch_size
 
 total_c7x_1_ddr = total_c7x_1_local_ddr + total_c7x_1_scratch_ddr
 
 # C7x 2 Persistent DDR
-c7x_2_ddr_local_heap_non_cacheable_addr  = ddr_mem_addr_hi;
+c7x_2_ddr_local_heap_non_cacheable_addr  = c7x_1_ddr_scratch_addr + c7x_1_ddr_scratch_size;
 c7x_2_ddr_local_heap_non_cacheable_addr_phys  = c7x_1_ddr_scratch_addr_phys + c7x_1_ddr_scratch_size;
-c7x_2_ddr_local_heap_non_cacheable_size  = 128*MB;
+c7x_2_ddr_local_heap_non_cacheable_size  = 32*MB;
 c7x_2_ddr_local_heap_addr = c7x_2_ddr_local_heap_non_cacheable_addr + c7x_2_ddr_local_heap_non_cacheable_size;
 c7x_2_ddr_local_heap_addr_phys = c7x_2_ddr_local_heap_non_cacheable_addr_phys + c7x_2_ddr_local_heap_non_cacheable_size;
-c7x_2_ddr_local_heap_size = 128*MB;
+c7x_2_ddr_local_heap_size = 32*MB;
 total_c7x_2_local_ddr = c7x_2_ddr_local_heap_non_cacheable_size + c7x_2_ddr_local_heap_size
 
 # C7x 2 Scratch DDR
 c7x_2_ddr_scratch_non_cacheable_addr     = c7x_2_ddr_local_heap_addr + c7x_2_ddr_local_heap_size;
 c7x_2_ddr_scratch_non_cacheable_addr_phys     = c7x_2_ddr_local_heap_addr_phys + c7x_2_ddr_local_heap_size;
-c7x_2_ddr_scratch_non_cacheable_size     = 128*MB;
+c7x_2_ddr_scratch_non_cacheable_size     = 32*MB;
 c7x_2_ddr_scratch_addr = c7x_2_ddr_scratch_non_cacheable_addr + c7x_2_ddr_scratch_non_cacheable_size;
 c7x_2_ddr_scratch_addr_phys = c7x_2_ddr_scratch_non_cacheable_addr_phys + c7x_2_ddr_scratch_non_cacheable_size;
-c7x_2_ddr_scratch_size = 128*MB;
+c7x_2_ddr_scratch_size = 32*MB;
 total_c7x_2_scratch_ddr = c7x_2_ddr_scratch_non_cacheable_size + c7x_2_ddr_scratch_size
 
 total_c7x_2_ddr = total_c7x_2_local_ddr + total_c7x_2_scratch_ddr
 
 # C7x 3 Persistent DDR
-c7x_3_ddr_local_heap_non_cacheable_addr  = ddr_mem_addr_hi;
+c7x_3_ddr_local_heap_non_cacheable_addr  = c7x_2_ddr_scratch_addr + c7x_2_ddr_scratch_size;
 c7x_3_ddr_local_heap_non_cacheable_addr_phys  = c7x_2_ddr_scratch_addr_phys + c7x_2_ddr_scratch_size;
-c7x_3_ddr_local_heap_non_cacheable_size  = 128*MB;
+c7x_3_ddr_local_heap_non_cacheable_size  = 32*MB;
 c7x_3_ddr_local_heap_addr = c7x_3_ddr_local_heap_non_cacheable_addr + c7x_3_ddr_local_heap_non_cacheable_size;
 c7x_3_ddr_local_heap_addr_phys = c7x_3_ddr_local_heap_non_cacheable_addr_phys + c7x_3_ddr_local_heap_non_cacheable_size;
-c7x_3_ddr_local_heap_size = 128*MB;
+c7x_3_ddr_local_heap_size = 32*MB;
 total_c7x_3_local_ddr = c7x_3_ddr_local_heap_non_cacheable_size + c7x_3_ddr_local_heap_size
 # C7x 3 Scratch DDR
 c7x_3_ddr_scratch_non_cacheable_addr     = c7x_3_ddr_local_heap_addr + c7x_3_ddr_local_heap_size;
 c7x_3_ddr_scratch_non_cacheable_addr_phys     = c7x_3_ddr_local_heap_addr_phys + c7x_3_ddr_local_heap_size;
-c7x_3_ddr_scratch_non_cacheable_size     = 128*MB;
+c7x_3_ddr_scratch_non_cacheable_size     = 32*MB;
 c7x_3_ddr_scratch_addr = c7x_3_ddr_scratch_non_cacheable_addr + c7x_3_ddr_scratch_non_cacheable_size;
 c7x_3_ddr_scratch_addr_phys = c7x_3_ddr_scratch_non_cacheable_addr_phys + c7x_3_ddr_scratch_non_cacheable_size;
-c7x_3_ddr_scratch_size = 128*MB;
+c7x_3_ddr_scratch_size = 32*MB;
 total_c7x_3_scratch_ddr = c7x_3_ddr_scratch_non_cacheable_size + c7x_3_ddr_scratch_size
 
 total_c7x_3_ddr = total_c7x_3_local_ddr + total_c7x_3_scratch_ddr
 
 # C7x 4 Persistent DDR
-c7x_4_ddr_local_heap_non_cacheable_addr  = ddr_mem_addr_hi;
+c7x_4_ddr_local_heap_non_cacheable_addr  = c7x_3_ddr_scratch_addr + c7x_3_ddr_scratch_size;
 c7x_4_ddr_local_heap_non_cacheable_addr_phys  = c7x_3_ddr_scratch_addr_phys + c7x_3_ddr_scratch_size;
-c7x_4_ddr_local_heap_non_cacheable_size  = 128*MB;
+c7x_4_ddr_local_heap_non_cacheable_size  = 32*MB;
 c7x_4_ddr_local_heap_addr = c7x_4_ddr_local_heap_non_cacheable_addr + c7x_4_ddr_local_heap_non_cacheable_size;
 c7x_4_ddr_local_heap_addr_phys = c7x_4_ddr_local_heap_non_cacheable_addr_phys + c7x_4_ddr_local_heap_non_cacheable_size;
-c7x_4_ddr_local_heap_size = 128*MB;
+c7x_4_ddr_local_heap_size = 32*MB;
 total_c7x_4_local_ddr = c7x_4_ddr_local_heap_non_cacheable_size + c7x_4_ddr_local_heap_size
 
 # C7x 4 Scratch DDR
 c7x_4_ddr_scratch_non_cacheable_addr     = c7x_4_ddr_local_heap_addr + c7x_4_ddr_local_heap_size;
 c7x_4_ddr_scratch_non_cacheable_addr_phys     = c7x_4_ddr_local_heap_addr_phys + c7x_4_ddr_local_heap_size;
-c7x_4_ddr_scratch_non_cacheable_size     = 128*MB;
+c7x_4_ddr_scratch_non_cacheable_size     = 32*MB;
 c7x_4_ddr_scratch_addr = c7x_4_ddr_scratch_non_cacheable_addr + c7x_4_ddr_scratch_non_cacheable_size;
 c7x_4_ddr_scratch_addr_phys = c7x_4_ddr_scratch_non_cacheable_addr_phys + c7x_4_ddr_scratch_non_cacheable_size;
-c7x_4_ddr_scratch_size = 128*MB;
+c7x_4_ddr_scratch_size = 32*MB;
 total_c7x_4_scratch_ddr = c7x_4_ddr_scratch_non_cacheable_size + c7x_4_ddr_scratch_size
 
 total_c7x_4_ddr = total_c7x_4_local_ddr + total_c7x_4_scratch_ddr
 
 total_c7x_ddr = total_c7x_1_ddr + total_c7x_2_ddr + total_c7x_3_ddr + total_c7x_4_ddr
 
-# Virtual address for C7x 1 corresponding to physical addresses for C7x2, C7x3, C7x4
-c7x_1_2_ddr_local_heap_non_cacheable_addr = c7x_1_ddr_scratch_addr + c7x_1_ddr_scratch_size;
-c7x_1_3_ddr_local_heap_non_cacheable_addr = c7x_1_2_ddr_local_heap_non_cacheable_addr + c7x_2_ddr_local_heap_non_cacheable_size;
-c7x_1_4_ddr_local_heap_non_cacheable_addr = c7x_1_3_ddr_local_heap_non_cacheable_addr + c7x_3_ddr_local_heap_non_cacheable_size;
-
-c7x_1_2_ddr_local_heap_addr = c7x_1_4_ddr_local_heap_non_cacheable_addr + c7x_4_ddr_local_heap_non_cacheable_size;
-c7x_1_3_ddr_local_heap_addr = c7x_1_2_ddr_local_heap_addr + c7x_2_ddr_local_heap_size;
-c7x_1_4_ddr_local_heap_addr = c7x_1_3_ddr_local_heap_addr + c7x_3_ddr_local_heap_size;
-
-c7x_1_2_ddr_scratch_non_cacheable_addr = c7x_1_4_ddr_local_heap_addr + c7x_4_ddr_local_heap_size;
-c7x_1_3_ddr_scratch_non_cacheable_addr = c7x_1_2_ddr_scratch_non_cacheable_addr + c7x_2_ddr_scratch_non_cacheable_size;
-c7x_1_4_ddr_scratch_non_cacheable_addr = c7x_1_3_ddr_scratch_non_cacheable_addr + c7x_3_ddr_scratch_non_cacheable_size;
-
-c7x_1_2_ddr_scratch_addr = c7x_1_4_ddr_scratch_non_cacheable_addr + c7x_4_ddr_scratch_non_cacheable_size;
-c7x_1_3_ddr_scratch_addr = c7x_1_2_ddr_scratch_addr + c7x_2_ddr_scratch_size;
-c7x_1_4_ddr_scratch_addr = c7x_1_3_ddr_scratch_addr + c7x_3_ddr_scratch_size;
-
-# Virtual address for C7x 2 corresponding to physical addresses for C7x1, C7x3, C7x4
-c7x_2_1_ddr_local_heap_non_cacheable_addr = c7x_2_ddr_scratch_addr + c7x_2_ddr_scratch_size;
-c7x_2_3_ddr_local_heap_non_cacheable_addr = c7x_2_1_ddr_local_heap_non_cacheable_addr + c7x_1_ddr_local_heap_non_cacheable_size;
-c7x_2_4_ddr_local_heap_non_cacheable_addr = c7x_2_3_ddr_local_heap_non_cacheable_addr + c7x_3_ddr_local_heap_non_cacheable_size;
-
-c7x_2_1_ddr_local_heap_addr = c7x_2_4_ddr_local_heap_non_cacheable_addr + c7x_4_ddr_local_heap_non_cacheable_size;
-c7x_2_3_ddr_local_heap_addr = c7x_2_1_ddr_local_heap_addr + c7x_1_ddr_local_heap_size;
-c7x_2_4_ddr_local_heap_addr = c7x_2_3_ddr_local_heap_addr + c7x_3_ddr_local_heap_size;
-
-c7x_2_1_ddr_scratch_non_cacheable_addr = c7x_2_4_ddr_local_heap_addr + c7x_4_ddr_local_heap_size;
-c7x_2_3_ddr_scratch_non_cacheable_addr = c7x_2_1_ddr_scratch_non_cacheable_addr + c7x_1_ddr_scratch_non_cacheable_size;
-c7x_2_4_ddr_scratch_non_cacheable_addr = c7x_2_3_ddr_scratch_non_cacheable_addr + c7x_3_ddr_scratch_non_cacheable_size;
-
-c7x_2_1_ddr_scratch_addr = c7x_2_4_ddr_scratch_non_cacheable_addr + c7x_4_ddr_scratch_non_cacheable_size;
-c7x_2_3_ddr_scratch_addr = c7x_2_1_ddr_scratch_addr + c7x_1_ddr_scratch_size;
-c7x_2_4_ddr_scratch_addr = c7x_2_3_ddr_scratch_addr + c7x_3_ddr_scratch_size;
-
-# Virtual address for C7x 3 corresponding to physical addresses for C7x1, C7x2, C7x4
-c7x_3_1_ddr_local_heap_non_cacheable_addr = c7x_3_ddr_scratch_addr + c7x_3_ddr_scratch_size;
-c7x_3_2_ddr_local_heap_non_cacheable_addr = c7x_3_1_ddr_local_heap_non_cacheable_addr + c7x_1_ddr_local_heap_non_cacheable_size;
-c7x_3_4_ddr_local_heap_non_cacheable_addr = c7x_3_2_ddr_local_heap_non_cacheable_addr + c7x_2_ddr_local_heap_non_cacheable_size;
-
-c7x_3_1_ddr_local_heap_addr = c7x_3_4_ddr_local_heap_non_cacheable_addr + c7x_4_ddr_local_heap_non_cacheable_size;
-c7x_3_2_ddr_local_heap_addr = c7x_3_1_ddr_local_heap_addr + c7x_1_ddr_local_heap_size;
-c7x_3_4_ddr_local_heap_addr = c7x_3_2_ddr_local_heap_addr + c7x_2_ddr_local_heap_size;
-
-c7x_3_1_ddr_scratch_non_cacheable_addr = c7x_3_4_ddr_local_heap_addr + c7x_4_ddr_local_heap_size;
-c7x_3_2_ddr_scratch_non_cacheable_addr = c7x_3_1_ddr_scratch_non_cacheable_addr + c7x_1_ddr_scratch_non_cacheable_size;
-c7x_3_4_ddr_scratch_non_cacheable_addr = c7x_3_2_ddr_scratch_non_cacheable_addr + c7x_2_ddr_scratch_non_cacheable_size;
-
-c7x_3_1_ddr_scratch_addr = c7x_3_4_ddr_scratch_non_cacheable_addr + c7x_4_ddr_scratch_non_cacheable_size;
-c7x_3_2_ddr_scratch_addr = c7x_3_1_ddr_scratch_addr + c7x_1_ddr_scratch_size;
-c7x_3_4_ddr_scratch_addr = c7x_3_2_ddr_scratch_addr + c7x_2_ddr_scratch_size;
-
-# Virtual address for C7x 4 corresponding to physical addresses for C7x1, C7x2, C7x3
-c7x_4_1_ddr_local_heap_non_cacheable_addr = c7x_4_ddr_scratch_addr + c7x_4_ddr_scratch_size;
-c7x_4_2_ddr_local_heap_non_cacheable_addr = c7x_4_1_ddr_local_heap_non_cacheable_addr + c7x_1_ddr_local_heap_non_cacheable_size;
-c7x_4_3_ddr_local_heap_non_cacheable_addr = c7x_4_2_ddr_local_heap_non_cacheable_addr + c7x_2_ddr_local_heap_non_cacheable_size;
-
-c7x_4_1_ddr_local_heap_addr = c7x_4_3_ddr_local_heap_non_cacheable_addr + c7x_3_ddr_local_heap_non_cacheable_size;
-c7x_4_2_ddr_local_heap_addr = c7x_4_1_ddr_local_heap_addr + c7x_1_ddr_local_heap_size;
-c7x_4_3_ddr_local_heap_addr = c7x_4_2_ddr_local_heap_addr + c7x_2_ddr_local_heap_size;
-
-c7x_4_1_ddr_scratch_non_cacheable_addr = c7x_4_3_ddr_local_heap_addr + c7x_3_ddr_local_heap_size;
-c7x_4_2_ddr_scratch_non_cacheable_addr = c7x_4_1_ddr_scratch_non_cacheable_addr + c7x_1_ddr_scratch_non_cacheable_size;
-c7x_4_3_ddr_scratch_non_cacheable_addr = c7x_4_2_ddr_scratch_non_cacheable_addr + c7x_2_ddr_scratch_non_cacheable_size;
-
-c7x_4_1_ddr_scratch_addr = c7x_4_3_ddr_scratch_non_cacheable_addr + c7x_3_ddr_scratch_non_cacheable_size;
-c7x_4_2_ddr_scratch_addr = c7x_4_1_ddr_scratch_addr + c7x_1_ddr_scratch_size;
-c7x_4_3_ddr_scratch_addr = c7x_4_2_ddr_scratch_addr + c7x_2_ddr_scratch_size;
-
 # Shared memory for DMA Buf FD carveout (located in high mem)
 ddr_shared_mem_addr_phys  = c7x_4_ddr_scratch_addr_phys + c7x_4_ddr_scratch_size;
+ddr_shared_mem_addr       = c7x_4_ddr_scratch_addr_phys + c7x_4_ddr_scratch_size;
 ddr_shared_mem_size       = SHARED_MEM_SIZE - uboot_reloc_mem_size;
 
 #
@@ -642,21 +571,6 @@ c7x_1_ddr_scratch_non_cacheable_phys    = MemSection("DDR_C7X_1_SCRATCH_NON_CACH
 c7x_1_ddr_scratch         = MemSection("DDR_C7X_1_SCRATCH", "RWIX", c7x_1_ddr_scratch_addr, c7x_1_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_1 for Scratch Memory");
 c7x_1_ddr_scratch_phys    = MemSection("DDR_C7X_1_SCRATCH_PHYS", "RWIX", c7x_1_ddr_scratch_addr_phys, c7x_1_ddr_scratch_size, "Physical address of cacheable DDR for c7x_1 for Scratch Memory");
 
-c7x_1_2_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_1_2_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_1_2_ddr_local_heap_non_cacheable_addr, c7x_2_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_2 for local heap wrt c7x_1");
-c7x_1_2_ddr_local_heap      = MemSection("DDR_C7X_1_2_LOCAL_HEAP", "RWIX", c7x_1_2_ddr_local_heap_addr, c7x_2_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_2 for local heap wrt c7x_1");
-c7x_1_2_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_1_2_SCRATCH_NON_CACHEABLE", "RWIX", c7x_1_2_ddr_scratch_non_cacheable_addr, c7x_2_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_2 for Scratch Memory wrt c7x_1");
-c7x_1_2_ddr_scratch         = MemSection("DDR_C7X_1_2_SCRATCH", "RWIX", c7x_1_2_ddr_scratch_addr, c7x_2_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_2 for Scratch Memory wrt c7x_1");
-
-c7x_1_3_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_1_3_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_1_3_ddr_local_heap_non_cacheable_addr, c7x_3_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_3 for local heap wrt c7x_1");
-c7x_1_3_ddr_local_heap      = MemSection("DDR_C7X_1_3_LOCAL_HEAP", "RWIX", c7x_1_3_ddr_local_heap_addr, c7x_3_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_3 for local heap wrt c7x_1");
-c7x_1_3_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_1_3_SCRATCH_NON_CACHEABLE", "RWIX", c7x_1_3_ddr_scratch_non_cacheable_addr, c7x_3_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_3 for Scratch Memory wrt c7x_1");
-c7x_1_3_ddr_scratch         = MemSection("DDR_C7X_1_3_SCRATCH", "RWIX", c7x_1_3_ddr_scratch_addr, c7x_3_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_3 for Scratch Memory wrt c7x_1");
-
-c7x_1_4_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_1_4_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_1_4_ddr_local_heap_non_cacheable_addr, c7x_4_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_4 for local heap wrt c7x_1");
-c7x_1_4_ddr_local_heap      = MemSection("DDR_C7X_1_4_LOCAL_HEAP", "RWIX", c7x_1_4_ddr_local_heap_addr, c7x_4_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_4 for local heap wrt c7x_1");
-c7x_1_4_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_1_4_SCRATCH_NON_CACHEABLE", "RWIX", c7x_1_4_ddr_scratch_non_cacheable_addr, c7x_4_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_4 for Scratch Memory wrt c7x_1");
-c7x_1_4_ddr_scratch         = MemSection("DDR_C7X_1_4_SCRATCH", "RWIX", c7x_1_4_ddr_scratch_addr, c7x_4_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_4 for Scratch Memory wrt c7x_1");
-
 c7x_1_ddr_total           = MemSection("DDR_C7x_1_DTS", "", 0, 0, "DDR for C7x_1 for all sections, used for reserving memory in DTS file");
 c7x_1_ddr_total.concat(c7x_1_ddr_resource_table);
 c7x_1_ddr_total.concat(c7x_1_ddr_boot);
@@ -681,21 +595,6 @@ c7x_2_ddr_scratch_non_cacheable_phys    = MemSection("DDR_C7X_2_SCRATCH_NON_CACH
 c7x_2_ddr_scratch         = MemSection("DDR_C7X_2_SCRATCH", "RWIX", c7x_2_ddr_scratch_addr, c7x_2_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_2 for Scratch Memory");
 c7x_2_ddr_scratch_phys    = MemSection("DDR_C7X_2_SCRATCH_PHYS", "RWIX", c7x_2_ddr_scratch_addr_phys, c7x_2_ddr_scratch_size, "Physical address of cacheable DDR for c7x_2 for Scratch Memory");
 
-c7x_2_1_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_2_1_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_2_1_ddr_local_heap_non_cacheable_addr, c7x_1_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_1 for local heap wrt c7x_2");
-c7x_2_1_ddr_local_heap      = MemSection("DDR_C7X_2_1_LOCAL_HEAP", "RWIX", c7x_2_1_ddr_local_heap_addr, c7x_1_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_1 for local heap wrt c7x_2");
-c7x_2_1_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_2_1_SCRATCH_NON_CACHEABLE", "RWIX", c7x_2_1_ddr_scratch_non_cacheable_addr, c7x_1_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_1 for Scratch Memory wrt c7x_2");
-c7x_2_1_ddr_scratch         = MemSection("DDR_C7X_2_1_SCRATCH", "RWIX", c7x_2_1_ddr_scratch_addr, c7x_1_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_1 for Scratch Memory wrt c7x_2");
-
-c7x_2_3_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_2_3_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_2_3_ddr_local_heap_non_cacheable_addr, c7x_3_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_3 for local heap wrt c7x_2");
-c7x_2_3_ddr_local_heap      = MemSection("DDR_C7X_2_3_LOCAL_HEAP", "RWIX", c7x_2_3_ddr_local_heap_addr, c7x_3_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_3 for local heap wrt c7x_2");
-c7x_2_3_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_2_3_SCRATCH_NON_CACHEABLE", "RWIX", c7x_2_3_ddr_scratch_non_cacheable_addr, c7x_3_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_3 for Scratch Memory wrt c7x_2");
-c7x_2_3_ddr_scratch         = MemSection("DDR_C7X_2_3_SCRATCH", "RWIX", c7x_2_3_ddr_scratch_addr, c7x_3_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_3 for Scratch Memory wrt c7x_2");
-
-c7x_2_4_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_2_4_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_2_4_ddr_local_heap_non_cacheable_addr, c7x_4_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_4 for local heap wrt c7x_2");
-c7x_2_4_ddr_local_heap      = MemSection("DDR_C7X_2_4_LOCAL_HEAP", "RWIX", c7x_2_4_ddr_local_heap_addr, c7x_4_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_4 for local heap wrt c7x_2");
-c7x_2_4_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_2_4_SCRATCH_NON_CACHEABLE", "RWIX", c7x_2_4_ddr_scratch_non_cacheable_addr, c7x_4_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_4 for Scratch Memory wrt c7x_2");
-c7x_2_4_ddr_scratch         = MemSection("DDR_C7X_2_4_SCRATCH", "RWIX", c7x_2_4_ddr_scratch_addr, c7x_4_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_4 for Scratch Memory wrt c7x_2");
-
 c7x_2_ddr_total           = MemSection("DDR_C7x_2_DTS", "", 0, 0, "DDR for C7x_2 for all sections, used for reserving memory in DTS file");
 c7x_2_ddr_total.concat(c7x_2_ddr_resource_table);
 c7x_2_ddr_total.concat(c7x_2_ddr_boot);
@@ -720,21 +619,6 @@ c7x_3_ddr_scratch_non_cacheable_phys    = MemSection("DDR_C7X_3_SCRATCH_NON_CACH
 c7x_3_ddr_scratch         = MemSection("DDR_C7X_3_SCRATCH", "RWIX", c7x_3_ddr_scratch_addr, c7x_3_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_3 for Scratch Memory");
 c7x_3_ddr_scratch_phys    = MemSection("DDR_C7X_3_SCRATCH_PHYS", "RWIX", c7x_3_ddr_scratch_addr_phys, c7x_3_ddr_scratch_size, "Physical address of cacheable DDR for c7x_3 for Scratch Memory");
 
-c7x_3_1_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_3_1_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_3_1_ddr_local_heap_non_cacheable_addr, c7x_1_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_1 for local heap wrt c7x_3");
-c7x_3_1_ddr_local_heap      = MemSection("DDR_C7X_3_1_LOCAL_HEAP", "RWIX", c7x_3_1_ddr_local_heap_addr, c7x_1_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_1 for local heap wrt c7x_3");
-c7x_3_1_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_3_1_SCRATCH_NON_CACHEABLE", "RWIX", c7x_3_1_ddr_scratch_non_cacheable_addr, c7x_1_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_1 for Scratch Memory wrt c7x_3");
-c7x_3_1_ddr_scratch         = MemSection("DDR_C7X_3_1_SCRATCH", "RWIX", c7x_3_1_ddr_scratch_addr, c7x_1_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_1 for Scratch Memory wrt c7x_3");
-
-c7x_3_2_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_3_2_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_3_2_ddr_local_heap_non_cacheable_addr, c7x_2_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_2 for local heap wrt c7x_3");
-c7x_3_2_ddr_local_heap      = MemSection("DDR_C7X_3_2_LOCAL_HEAP", "RWIX", c7x_3_2_ddr_local_heap_addr, c7x_2_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_2 for local heap wrt c7x_3");
-c7x_3_2_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_3_2_SCRATCH_NON_CACHEABLE", "RWIX", c7x_3_2_ddr_scratch_non_cacheable_addr, c7x_2_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_2 for Scratch Memory wrt c7x_3");
-c7x_3_2_ddr_scratch         = MemSection("DDR_C7X_3_2_SCRATCH", "RWIX", c7x_3_2_ddr_scratch_addr, c7x_2_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_2 for Scratch Memory wrt c7x_3");
-
-c7x_3_4_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_3_4_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_3_4_ddr_local_heap_non_cacheable_addr, c7x_4_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_4 for local heap wrt c7x_3");
-c7x_3_4_ddr_local_heap      = MemSection("DDR_C7X_3_4_LOCAL_HEAP", "RWIX", c7x_3_4_ddr_local_heap_addr, c7x_4_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_4 for local heap wrt c7x_3");
-c7x_3_4_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_3_4_SCRATCH_NON_CACHEABLE", "RWIX", c7x_3_4_ddr_scratch_non_cacheable_addr, c7x_4_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_4 for Scratch Memory wrt c7x_3");
-c7x_3_4_ddr_scratch         = MemSection("DDR_C7X_3_4_SCRATCH", "RWIX", c7x_3_4_ddr_scratch_addr, c7x_4_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_4 for Scratch Memory wrt c7x_3");
-
 c7x_3_ddr_total           = MemSection("DDR_C7x_3_DTS", "", 0, 0, "DDR for C7x_3 for all sections, used for reserving memory in DTS file");
 c7x_3_ddr_total.concat(c7x_3_ddr_resource_table);
 c7x_3_ddr_total.concat(c7x_3_ddr_boot);
@@ -759,21 +643,6 @@ c7x_4_ddr_scratch_non_cacheable_phys    = MemSection("DDR_C7X_4_SCRATCH_NON_CACH
 c7x_4_ddr_scratch         = MemSection("DDR_C7X_4_SCRATCH", "RWIX", c7x_4_ddr_scratch_addr, c7x_4_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_4 for Scratch Memory");
 c7x_4_ddr_scratch_phys    = MemSection("DDR_C7X_4_SCRATCH_PHYS", "RWIX", c7x_4_ddr_scratch_addr_phys, c7x_4_ddr_scratch_size, "Physical address of cacheable DDR for c7x_4 for Scratch Memory");
 
-c7x_4_1_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_4_1_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_4_1_ddr_local_heap_non_cacheable_addr, c7x_1_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_1 for local heap wrt c7x_4");
-c7x_4_1_ddr_local_heap      = MemSection("DDR_C7X_4_1_LOCAL_HEAP", "RWIX", c7x_4_1_ddr_local_heap_addr, c7x_1_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_1 for local heap wrt c7x_4");
-c7x_4_1_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_4_1_SCRATCH_NON_CACHEABLE", "RWIX", c7x_4_1_ddr_scratch_non_cacheable_addr, c7x_1_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_1 for Scratch Memory wrt c7x_4");
-c7x_4_1_ddr_scratch         = MemSection("DDR_C7X_4_1_SCRATCH", "RWIX", c7x_4_1_ddr_scratch_addr, c7x_1_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_1 for Scratch Memory wrt c7x_4");
-
-c7x_4_2_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_4_2_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_4_2_ddr_local_heap_non_cacheable_addr, c7x_2_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_2 for local heap wrt c7x_4");
-c7x_4_2_ddr_local_heap      = MemSection("DDR_C7X_4_2_LOCAL_HEAP", "RWIX", c7x_4_2_ddr_local_heap_addr, c7x_2_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_2 for local heap wrt c7x_4");
-c7x_4_2_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_4_2_SCRATCH_NON_CACHEABLE", "RWIX", c7x_4_2_ddr_scratch_non_cacheable_addr, c7x_2_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_2 for Scratch Memory wrt c7x_4");
-c7x_4_2_ddr_scratch         = MemSection("DDR_C7X_4_2_SCRATCH", "RWIX", c7x_4_2_ddr_scratch_addr, c7x_2_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_2 for Scratch Memory wrt c7x_4");
-
-c7x_4_3_ddr_local_heap_non_cacheable = MemSection("DDR_C7X_4_3_LOCAL_HEAP_NON_CACHEABLE", "RWIX", c7x_4_3_ddr_local_heap_non_cacheable_addr, c7x_3_ddr_local_heap_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_3 for local heap wrt c7x_4");
-c7x_4_3_ddr_local_heap      = MemSection("DDR_C7X_4_3_LOCAL_HEAP", "RWIX", c7x_4_3_ddr_local_heap_addr, c7x_3_ddr_local_heap_size, "Virtual address of cacheable DDR for c7x_3 for local heap wrt c7x_4");
-c7x_4_3_ddr_scratch_non_cacheable         = MemSection("DDR_C7X_4_3_SCRATCH_NON_CACHEABLE", "RWIX", c7x_4_3_ddr_scratch_non_cacheable_addr, c7x_3_ddr_scratch_non_cacheable_size, "Virtual address of non-cacheable DDR for c7x_3 for Scratch Memory wrt c7x_4");
-c7x_4_3_ddr_scratch         = MemSection("DDR_C7X_4_3_SCRATCH", "RWIX", c7x_4_3_ddr_scratch_addr, c7x_3_ddr_scratch_size, "Virtual address of cacheable DDR for c7x_3 for Scratch Memory wrt c7x_4");
-
 c7x_4_ddr_total           = MemSection("DDR_C7x_4_DTS", "", 0, 0, "DDR for C7x_4 for all sections, used for reserving memory in DTS file");
 c7x_4_ddr_total.concat(c7x_4_ddr_resource_table);
 c7x_4_ddr_total.concat(c7x_4_ddr_boot);
@@ -782,6 +651,8 @@ c7x_4_ddr_total.concat(c7x_4_ddr_secure_vecs);
 c7x_4_ddr_total.concat(c7x_4_ddr);
 c7x_4_ddr_total.setDtsName("vision_apps_c71_3_memory_region", "vision-apps-c71_3-memory");
 
+c7x_ddr_high_mem_phy  = MemSection("DDR_C7X_HIGH_MEM", "RWIX", c7x_1_ddr_local_heap_non_cacheable_addr_phys, total_c7x_ddr, "High mem sections for c7x-1 thru c7x-4 for code/data, local heap and scratch");
+
 # Shared memory memory sections in DDR
 app_log_mem            = MemSection("APP_LOG_MEM"        , "", app_log_mem_addr       , app_log_mem_size       , "Memory for remote core logging");
 tiovx_obj_desc_mem     = MemSection("TIOVX_OBJ_DESC_MEM" , "", tiovx_obj_desc_mem_addr, tiovx_obj_desc_mem_size, "Memory for TI OpenVX shared memory. MUST be non-cached or cache-coherent");
@@ -808,15 +679,9 @@ vision_apps_core_heaps_lo.concat(mcu3_1_ddr_local_heap);
 vision_apps_core_heaps_lo.concat(mcu4_0_ddr_local_heap);
 vision_apps_core_heaps_lo.concat(mcu4_0_ddr_viss_config_heap);
 vision_apps_core_heaps_lo.concat(mcu4_1_ddr_local_heap);
+vision_apps_core_heaps_lo.concat(c7x_ddr_high_mem_phy);
 vision_apps_core_heaps_lo.setDtsName("vision_apps_core_heaps_lo", "vision-apps-core-heap-memory-lo");
 
-c7x_ddr_high_mem_phy  = MemSection("DDR_C7X_HIGH_MEM", "RWIX", ddr_mem_addr_hi_phys, total_c7x_ddr, "High mem sections for c7x-1 thru c7x-4 for code/data, local heap and scratch");
-
-c7x_ddr_heaps_hi = MemSection("DDR_C7X_HIGH_MEM_DTS", "", 0, 0, "C7X DDR memory sections in 40bit address range of DDR");
-c7x_ddr_heaps_hi.concat(c7x_ddr_high_mem_phy);
-c7x_ddr_heaps_hi.setDtsName("c7x_ddr_heaps_hi", "c7x-ddr-heaps-hi");
-c7x_ddr_heaps_hi.splitOrigin(True)
-
 # this region should NOT have the "no-map" flag since we want ION to map this memory and do cache ops on it as needed
 ddr_shared_mem     = MemSection("DDR_SHARED_MEM"    , "", ddr_shared_mem_addr    , ddr_shared_mem_size    , "Memory for shared memory buffers in DDR");
 ddr_shared_mem_phys  = MemSection("DDR_SHARED_MEM_PHYS"    , "", ddr_shared_mem_addr_phys  , ddr_shared_mem_size    , "Physical address of memory for shared memory buffers in DDR");
@@ -985,18 +850,6 @@ c7x_1_mmap.addMemSection( c7x_1_ddr_local_heap_non_cacheable  );
 c7x_1_mmap.addMemSection( c7x_1_ddr_local_heap  );
 c7x_1_mmap.addMemSection( c7x_1_ddr_scratch_non_cacheable  );
 c7x_1_mmap.addMemSection( c7x_1_ddr_scratch  );
-c7x_1_mmap.addMemSection( c7x_1_2_ddr_local_heap_non_cacheable  );
-c7x_1_mmap.addMemSection( c7x_1_2_ddr_local_heap  );
-c7x_1_mmap.addMemSection( c7x_1_2_ddr_scratch_non_cacheable  );
-c7x_1_mmap.addMemSection( c7x_1_2_ddr_scratch  );
-c7x_1_mmap.addMemSection( c7x_1_3_ddr_local_heap_non_cacheable  );
-c7x_1_mmap.addMemSection( c7x_1_3_ddr_local_heap  );
-c7x_1_mmap.addMemSection( c7x_1_3_ddr_scratch_non_cacheable  );
-c7x_1_mmap.addMemSection( c7x_1_3_ddr_scratch  );
-c7x_1_mmap.addMemSection( c7x_1_4_ddr_local_heap_non_cacheable  );
-c7x_1_mmap.addMemSection( c7x_1_4_ddr_local_heap  );
-c7x_1_mmap.addMemSection( c7x_1_4_ddr_scratch_non_cacheable  );
-c7x_1_mmap.addMemSection( c7x_1_4_ddr_scratch  );
 c7x_1_mmap.addMemSection( ddr_shared_mem     );
 c7x_1_mmap.checkOverlap();
 
